//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "dtucfgheader.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ComboBox_COM->ItemIndex=0;
  ComboBox_DataBits->ItemIndex=3;
  ComboBox_CheckBits->ItemIndex=0;
  ComboBox_Baud->ItemIndex=9;
  ComboBox_StopBits->ItemIndex= 0;
  ComboBox_Mode->ItemIndex= 0;
  ComboBox_COMBaud->ItemIndex= 9;
  ComboBox_COMDataBits->ItemIndex= 3;
  ComboBox_COMStopBits->ItemIndex= 0;
  ComboBox_COMCheckBits->ItemIndex= 0;

  m_hDTU = 0;
  SetBtnState (0);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnClose(TObject *Sender, TCloseAction &Action)
{
    if(m_bEnterConfig == 1)
    {
        DTU_ExitConfig(m_hDTU, 0);
        DTU_Delete(m_hDTU);
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_EnterCfgClick(TObject *Sender)
{
    Addcom();
    int res=DTU_Init(m_hDTU);
    if(res==0||DTU_EnterConfig(m_hDTU)==0)
    {
        DTU_Delete (m_hDTU);
        m_hDTU = 0;
        if(res==0)
            ShowMessage ("޷򿪴");
        else
            ShowMessage ("޷豸");
        return;
    }
    m_bEnterConfig=1;
    SetBtnState(m_bEnterConfig);
}
//---------------------------------------------------------------------------


void TForm1::Addcom()
{
    if (m_hDTU!=0)
    {
        DTU_Delete(m_hDTU);
        m_hDTU=0;
    }
    int comind = ComboBox_COM->ItemIndex+1;
    int baud = StrToInt(ComboBox_Baud->Items->Strings[ComboBox_Baud->ItemIndex]);
    int databits = StrToInt(ComboBox_DataBits->Items->Strings[ComboBox_DataBits->ItemIndex]);
    int stopbits = StrToInt(ComboBox_StopBits->Items->Strings[ComboBox_StopBits->ItemIndex]);
    // int checkbits = StrToInt(ComboBox_CheckBits->Items->Strings[ComboBox_CheckBits->ItemIndex]);
    int checkbits = ComboBox_CheckBits->ItemIndex;
    m_hDTU = DTU_AddCOM(comind, baud, databits, checkbits, stopbits);
}

void TForm1::SetBtnState(BYTE started)
{
    if(started == 0)
        Button_EnterCfg->Enabled=True;
    else
        Button_EnterCfg->Enabled= False;
    m_bEnterConfig = started;
}

void __fastcall TForm1::Button_ExitCfgClick(TObject *Sender)
{
    HANDLE predtu=m_hDTU;
    if(m_hDTU == 0)
        Addcom();

    if(predtu==0&&DTU_Init(m_hDTU)==0)
    {
        DTU_Delete(m_hDTU);
        m_hDTU = 0;
        ShowMessage("޷豸");
        m_bEnterConfig=0;
        SetBtnState(m_bEnterConfig);
        return;
    }

    if(DTU_ExitConfig(m_hDTU,1)==0)
        ShowMessage("ʧ");
    m_bEnterConfig=0;
    SetBtnState(m_bEnterConfig);
    DTU_Delete(m_hDTU);
    m_hDTU=0;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button_GetInfoClick(TObject *Sender)
{
    if(IsInCfg()==0)
        return;
    if(DTU_GetAllConfig(m_hDTU)==0)
    {
        ShowMessage("ȡϢʧ");
        return;
    }
    AnsiString strinfo="ȡϢ:\r\n\r\n";
    char szcmd[20],szval[20];
    while(DTU_GetConfig(m_hDTU, szcmd, szval)==1)
    {
        FillInfo(szcmd, szval);
        strinfo= strinfo + ":";
        strinfo= strinfo +szcmd;
        strinfo= strinfo + "   ֵ:";
        strinfo= strinfo + szval;
        strinfo= strinfo +"\r\n";
    }
    ShowMessage(strinfo);

}
//---------------------------------------------------------------------------


int TForm1::IsInCfg()
{
    if(m_bEnterConfig ==0)
        ShowMessage("Ƚ״̬");

    return m_bEnterConfig;
}

void TForm1::FillInfo(char* szcmd, char* szval)
{
    if(StrComp(szcmd, CMD_DTUID) ==0)
        Edit_DevID->Text= szval;
    else if(StrComp(szcmd, CMD_PHON) ==0)
        Edit_Phone->Text= szval;
    else if(StrComp(szcmd, CMD_MODE) ==0)
        ComboBox_Mode->Text= szval;
    else if(StrComp(szcmd, CMD_SERBAUD) ==0)
        ComboBox_COMBaud->Text= szval;
    else if(StrComp(szcmd, CMD_SERDAT) == 0)
        ComboBox_COMDataBits->Text= szval;
    else if(StrComp(szcmd, CMD_SERSTP) ==0)
        ComboBox_COMStopBits->Text= szval;
    else if(StrComp(szcmd, CMD_SERCHK)==0) {
        //ComboBox_COMCheckBits->ItemIndex=StrToInt(szval);
        ComboBox_COMCheckBits->Text = szval;
    }

}
void __fastcall TForm1::Button_ModifyDevIDClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=Edit_DevID->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_DTUID, strval.c_str())!=1)
        ShowMessage("ʧ");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyPhoneClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=Edit_Phone->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_PHON, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyModeClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_Mode->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_MODE, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyBaudClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMBaud->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERBAUD, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyDataBitsClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMDataBits->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERDAT, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyStopBitsClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMStopBits->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERSTP, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ModifyCheckBitsClick(TObject *Sender)
{
    if(IsInCfg() ==0)
        return;
    AnsiString strval=ComboBox_COMCheckBits->Text;
    if(DTU_ConfigWrite(m_hDTU, CMD_SERCHK, strval.c_str())!=1)
        ShowMessage("ʧ");

}
//---------------------------------------------------------------------------

