// testconfigDlg.h : header file
//

#if !defined(AFX_TESTCONFIGDLG_H__FD116FD8_4AC0_4783_A5B8_53808DD24371__INCLUDED_)
#define AFX_TESTCONFIGDLG_H__FD116FD8_4AC0_4783_A5B8_53808DD24371__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CTestconfigDlg dialog

class CTestconfigDlg : public CDialog
{
// Construction
public:
	void FillInfo(char*szcmd,char* szval);
	int IsInCfg();
	void SetBtnState(int started);
	void AddCom();
	void ShowErr(LPCTSTR lpmsg);
	void InitCom();
	CTestconfigDlg(CWnd* pParent = NULL);	// standard constructor

	BYTE m_bEnterConfig;
	HANDLE m_hDTU;
	
// Dialog Data
	//{{AFX_DATA(CTestconfigDlg)
	enum { IDD = IDD_TESTCONFIG_DIALOG };
	CComboBox	m_ctlComboCOMStopBits;
	CComboBox	m_ctlComboCOMDataBits;
	CComboBox	m_ctlComboCOMCheckBits;
	CComboBox	m_ctlComboCOMBaud;
	CComboBox	m_ctlComboMode;
	CComboBox	m_ctlComboStopBits;
	CComboBox	m_ctlComboDataBits;
	CComboBox	m_ctlComboCom;
	CComboBox	m_ctlComboCheckBits;
	CComboBox	m_ctlComboBaud;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestconfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTestconfigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnButtonEntercfg();
	afx_msg void OnButtonExitconfig();
	afx_msg void OnButtonGetinfo();
	virtual void OnCancel();
	afx_msg void OnButtonModifyid();
	afx_msg void OnButtonModifyphone();
	afx_msg void OnButtonModifymode();
	afx_msg void OnButtonModifybaud();
	afx_msg void OnButtonModifydatabits();
	afx_msg void OnButtonModifystopbits();
	afx_msg void OnButtonModifycheckbits();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTCONFIGDLG_H__FD116FD8_4AC0_4783_A5B8_53808DD24371__INCLUDED_)
