unit DTUSet;

interface

uses
  WinTypes;

const
  DLL_NAME  = 'DTUSet.dll';//̬

type
PINT=^integer;
PBYTE=^BYTE;
PWORD=^SmallInt;

function DTU_AddCOM(comindex : integer; baud : integer; databits : integer; checkbits : integer; stopbits : integer)  : THandle;
stdcall;  external DLL_NAME;

function DTU_AddNetServer(szip : PCHAR; localport : integer; szpwd : PCHAR) : THandle;
stdcall;  external DLL_NAME;
function DTU_GetNewConnectedClient(hServerDTU : THandle)  : THandle;
stdcall;  external DLL_NAME;
function DTU_GetClientInfo(hDTU : THandle; pszdesip : PCHAR; pdesport : PWORD; sztype : PCHAR; szname : PCHAR; szid : PCHAR; szphone : PCHAR)  : integer;
stdcall;  external DLL_NAME;
function DTU_IsClientAvailable(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;
function DTU_SendData(hDTU : THandle; pdata : PBYTE; len : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_ReceiveData(hDTU : THandle; pdata : PBYTE; len : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_GetReceiveDataCount(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;
function DTU_SetReceiveDataTimeout(hDTU : THandle; tmout : integer)  : integer;
stdcall;  external DLL_NAME;


function DTU_AddTransferDes(hDTU : THandle; szip : PCHAR; port : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_DelTransferDes(hDTU : THandle; szip : PCHAR; port : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_ClearTransferDes(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;
function DTU_TransferDesDisTm(hDTU : THandle; distime : integer)  : integer;
stdcall;  external DLL_NAME;

function DTU_SendDataEx(hDTU : THandle; pdata : PBYTE; len : integer; needack : integer; waittm : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_ReceiveStateData(hDTU : THandle; pdata : PBYTE; len : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_SendStateData(hDTU : THandle; pdata : PBYTE; len : integer; needack : integer; waittm : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_Reset(hDTU : THandle; waittm : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_StopIO(hDTU : THandle; waittm : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_StartIO(hDTU : THandle; waittm : integer)  : integer;
stdcall;  external DLL_NAME;
function DTU_Disconnect(hDTU : THandle; waittm : integer)  : integer;
stdcall;  external DLL_NAME;

function DTU_Init(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;

function DTU_EnterConfig(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;
function DTU_GetAllConfig(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;
function DTU_GetConfig(hDTU : THandle; szcmd : PCHAR; szdata : PCHAR)  : integer;
stdcall;  external DLL_NAME;
function DTU_ConfigRead(hDTU : THandle; szcmd : PCHAR; szdata : PCHAR)  : integer;
stdcall;  external DLL_NAME;
function DTU_ConfigWrite(hDTU : THandle; szcmd : PCHAR; szdata : PCHAR)  : integer;
stdcall;  external DLL_NAME;
function DTU_ExitConfig(hDTU : THandle; wait : integer=1)  : integer;
stdcall;  external DLL_NAME;

function DTU_Uninit(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;

function DTU_Delete(hDTU : THandle)  : integer;
stdcall;  external DLL_NAME;


implementation

end.

