// testtransferDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testtransfer.h"
#include "testtransferDlg.h"
#include "DlgDev.h"
#include "dtucfgheader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTesttransferDlg dialog

CTesttransferDlg::CTesttransferDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTesttransferDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTesttransferDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTesttransferDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTesttransferDlg)
	DDX_Control(pDX, IDC_LIST_TRANSDEV, m_ctlListTransDev);
	DDX_Control(pDX, IDC_LIST_CLIENT, m_ctlListClient);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTesttransferDlg, CDialog)
	//{{AFX_MSG_MAP(CTesttransferDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SERVER, OnButtonServer)
	ON_WM_TIMER()
	ON_NOTIFY(NM_CLICK, IDC_LIST_CLIENT, OnClickListClient)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTesttransferDlg message handlers

BOOL CTesttransferDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetDlgItem(IDC_EDIT_PORT)->SetWindowText("4001");

	m_ctlListClient.InsertColumn(0,"IP",LVCFMT_LEFT,80,0);
	m_ctlListClient.InsertColumn(1,"˿",LVCFMT_LEFT,50,1);

	m_ctlListTransDev.InsertColumn(0,"IP",LVCFMT_LEFT,80,0);
	m_ctlListTransDev.InsertColumn(1,"˿",LVCFMT_LEFT,50,1);

	m_hServer=0;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTesttransferDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTesttransferDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTesttransferDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTesttransferDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CTesttransferDlg::OnCancel() 
{
	// TODO: Add extra validation here
	if(m_hServer!=0)
	{
		OnButtonServer();
	}

	CDialog::OnCancel();
}

void CTesttransferDlg::OnButtonServer() 
{
	// TODO: Add your control notification handler code here
	if(m_hServer==0)
	{
		CString str;
		GetDlgItem(IDC_EDIT_PORT)->GetWindowText(str);
		m_hServer=DTU_AddNetServer(NULL,atoi(str),NULL);
		DTU_Init(m_hServer);
		SetTimer(2,50,NULL);
	}
	else
	{
		KillTimer(2);
		ClearClients();
		DTU_Uninit(m_hServer);
		DTU_Delete(m_hServer);
		m_hServer=0;
	}
	GetDlgItem(IDC_BUTTON_SERVER)->SetWindowText(
		m_hServer==0?"":"ֹͣ");
}

void CTesttransferDlg::ClearClients()
{
	int sz=m_ctlListClient.GetItemCount();
	// for(int i=0;i<sz;i++)
	for (int i=sz-1; i>=0; i-- )
	{
		CLIENT* p=(CLIENT*)m_ctlListClient.GetItemData(i);
		DTU_Delete(p->hDTU);
		delete p;
	}
	m_ctlListClient.DeleteAllItems();
}

void CTesttransferDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==2)
	{
		HANDLE hdtu=DTU_GetNewConnectedClient(m_hServer);
		if(hdtu!=0)
		{
			char szip[20],sztype[20],szname[20],szid[20],szphone[30];
			int port;
			DTU_GetClientInfo(hdtu,szip,&port,sztype,szname,szid,szphone);
			CLIENT* p=new CLIENT;
			p->hDTU=hdtu;
			p->dev.validcount=0;
			int ind=m_ctlListClient.InsertItem(
				m_ctlListClient.GetItemCount(),szip);
			CString str1;
			str1.Format("%d",port);
			m_ctlListClient.SetItemText(ind,1,str1);
			m_ctlListClient.SetItemData(ind,(DWORD)p);
		}
		int sz=m_ctlListClient.GetItemCount();
		BYTE buf[1024];
		int del=0;
		for(int i=sz-1;i>=0;i--)
		{
			CLIENT* p=(CLIENT*)m_ctlListClient.GetItemData(i);
			if(!DTU_IsClientAvailable(p->hDTU))
			{
				DTU_Delete(p->hDTU);
				delete p;
				m_ctlListClient.DeleteItem(i);
				del=1;
			}
			else if(DTU_GetReceiveDataCount(p->hDTU)>0)//ڽݵͬʱϵͳڲԶת,һҪDTU_ReceiveDataϵͳܽת
			{
				DTU_ReceiveData(p->hDTU,buf,1024);
			}
		}
		if(del)
			RefreshTransDev();
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CTesttransferDlg::OnClickListClient(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	RefreshTransDev();
	
	*pResult = 0;
}

void CTesttransferDlg::RefreshTransDev()
{
	POSITION pos=m_ctlListClient.GetFirstSelectedItemPosition();
	m_ctlListTransDev.DeleteAllItems();
	if(pos==NULL)
	{
		return;
	}
	int ind=m_ctlListClient.GetNextSelectedItem(pos);
	CLIENT* p=(CLIENT*)m_ctlListClient.GetItemData(ind);
	CString str1;
	for(int i=0;i<p->dev.validcount;i++)
	{
		str1.Format("%d",p->dev.port[i]);
		int ind=m_ctlListTransDev.InsertItem(m_ctlListTransDev.GetItemCount(),
			p->dev.strip[i]);
		m_ctlListTransDev.SetItemText(ind,1,str1);
	}
}

void CTesttransferDlg::OnButtonAdd() 
{
	// TODO: Add your control notification handler code here
	POSITION pos=m_ctlListClient.GetFirstSelectedItemPosition();
	if(pos==NULL)
	{
		MessageBox("ѡһDTU豸");
		return;
	}
	int ind=m_ctlListClient.GetNextSelectedItem(pos);
	CLIENT* p=(CLIENT*)m_ctlListClient.GetItemData(ind);

	CString strip;
	int port;
	CString str1;
	GetDlgItem(IDC_EDIT_TRANSIP)->GetWindowText(strip);
	GetDlgItem(IDC_EDIT_TRANSPORT)->GetWindowText(str1);
	port=atoi(str1);
	p->dev.strip[p->dev.validcount]=strip;
	p->dev.port[p->dev.validcount]=port;
	p->dev.validcount++;
	str1.Format("%d",port);
	int a=m_ctlListTransDev.InsertItem(m_ctlListTransDev.GetItemCount(),strip);
	m_ctlListTransDev.SetItemText(a,1,str1);
	DTU_AddTransferDes(p->hDTU,(LPTSTR)(LPCTSTR)strip,port);
}
